#include<avr/io.h>
#include<avr/interrupt.h>

volatile int DELAY = 0;

SIGNAL(SIG_OUTPUT_COMPARE2)
{
	 TCNT2=0;
//	 PORTC = ~PORTC;  //Test, um direkt die halbe Interrupt-Frequenz zu sehen.
    if(DELAY>0)
        DELAY--;	
}

int main()
{
    //Timer2 in CTC-Mode ohne externe Ausgänge:
    TCCR2 = (0<<FOC2) | (1<<WGM20) | (0<<COM21) | (1<<COM20) | (0<<WGM21)
          | (1<<CS22) | (1<<CS21) | (0<<CS20);	
    //CS22 CS21 CS20  Teilung
    //001 /1          
    //010 /8
    //011 /32
    //100 /64
    //101 /128
    //110 /256
    //111 /1024          
    // fctc = fclock/(2*N*(1+OCR2))      
    //N=256, OCR2=17 => 1000Hz, 500Hz bei OC2.  
    //N=256, OCR2=170 => 100Hz, 50Hz bei OC2.  
    //Toggle on Compare-Match => Halbe Frequenz abrufbar auf Pin 21, OC2
    //Start mit niedriger gut wahrnehmbaerer Frequenz:
    //N=1024, OCR2=249 => 18Hz, 9Hz an OC2.     
    //N=1024, OCR2=149 => 30Hz, 15Hz an OC2.
    
    //Tatsächlich:    
    // fctc = fclock/(N*(1+OCR2))
    //N=256, OCR2=17 => 2000Hz, 1000Hz bei OC2.  
    //N=256, OCR2=179 => 200Hz, 100Hz bei OC2.  
          
    
    OCR2=179;    
    
    //Timermaske: Interrupt wenn Compare-Match bei Timer2:
    TIMSK |= (1<<OCIE2);
    
    //Interrupts aktivieren:
    sei();
    
    //Test: 1Hz Blinken auf PORTC:
    DDRC=255;
    PORTC=0;
            
    
    while(1)            
    {
        if(DELAY==0)
        {
            DELAY=100;	//Blinken von 1 Sekunde Periode
            PORTC = ~PORTC;	
        }    	
    }
}


